/*
 * This file is a part of the SteamWar software.
 *
 * Copyright (C) 2022  SteamWar.de-Serverteam
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <https://www.gnu.org/licenses/>.
 */

package de.steamwar.network;

import de.steamwar.network.packets.PacketHandler;
import org.junit.Before;
import org.junit.Test;

import java.lang.reflect.InvocationTargetException;

import static org.hamcrest.MatcherAssert.*;
import static org.hamcrest.Matchers.*;

public class PacketHandlerTest {

    TestPacketHandler packetHandler;

    @Before
    public void setUp() {
        packetHandler = new TestPacketHandler();
        packetHandler.register();
    }

    @Test
    public void testPacketHandler() {
        TestPacket packet = new TestPacket();
        try {
            PacketHandler.handlePacket(packet);
        } catch (Exception e) {
            assertThat(e, instanceOf(InvocationTargetException.class));
            assertThat(e.getCause(), instanceOf(SecurityException.class));
            assertThat(e.getCause().getMessage(), equalTo(packet.getClass().getName()));
        }
    }
}
